<html>
<head>
<title>OgreWin32Window.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreWin32Window.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreWin32Window_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Win32Window_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Win32Window_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreWin32Prerequisites_8h.html">OgreWin32Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderWindow_8h.html">OgreRenderWindow.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a><a class="code" href="classOgre_1_1Win32Window.html">00036</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1Win32Window.html">Win32Window</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keyword">public</span>:
<a name="l00039"></a>00039         <a class="code" href="classOgre_1_1Win32Window.html">Win32Window</a>(<a class="code" href="classOgre_1_1Win32GLSupport.html">Win32GLSupport</a> &amp;glsupport);
<a name="l00040"></a>00040         ~<a class="code" href="classOgre_1_1Win32Window.html">Win32Window</a>();
<a name="l00041"></a>00041 
<a name="l00042"></a>00042         <span class="keywordtype">void</span> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height,
<a name="l00043"></a>00043             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams);
<a name="l00044"></a>00044         <span class="keywordtype">void</span> setFullscreen(<span class="keywordtype">bool</span> fullScreen, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height);
<a name="l00045"></a>00045         <span class="keywordtype">void</span> destroy(<span class="keywordtype">void</span>);
<a name="l00046"></a>00046         <span class="keywordtype">bool</span> isActive(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00047"></a>00047         <span class="keywordtype">bool</span> isVisible() <span class="keyword">const</span>;
<a name="l00048"></a><a class="code" href="classOgre_1_1Win32Window.html#ab7c6077f77dd546afa11c011ef2dc34a">00048</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Win32Window.html#ab7c6077f77dd546afa11c011ef2dc34a" title="Indicates whether the window was set to hidden (not displayed)">isHidden</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHidden; }
<a name="l00049"></a>00049         <span class="keywordtype">void</span> setHidden(<span class="keywordtype">bool</span> hidden);
<a name="l00050"></a>00050         <span class="keywordtype">void</span> setVSyncEnabled(<span class="keywordtype">bool</span> vsync);
<a name="l00051"></a>00051         <span class="keywordtype">bool</span> isVSyncEnabled() <span class="keyword">const</span>;
<a name="l00052"></a>00052         <span class="keywordtype">void</span> setVSyncInterval(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> interval);
<a name="l00053"></a>00053         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getVSyncInterval() <span class="keyword">const</span>;
<a name="l00054"></a>00054         <span class="keywordtype">bool</span> isClosed(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00055"></a>00055         <span class="keywordtype">void</span> reposition(<span class="keywordtype">int</span> left, <span class="keywordtype">int</span> top);
<a name="l00056"></a>00056         <span class="keywordtype">void</span> resize(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height);
<a name="l00057"></a>00057         <span class="keywordtype">void</span> swapBuffers(<span class="keywordtype">bool</span> waitForVSync);
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyContentsToMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, FrameBuffer buffer);
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classOgre_1_1Win32Window.html#ab70d7160b238726f175a31d83fddb6ee">00062</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Win32Window.html#ab70d7160b238726f175a31d83fddb6ee">requiresTextureFlipping</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classOgre_1_1Win32Window.html#ac9003bb550e61ce3040e87ae8ac961ec">00064</a>         HWND <a class="code" href="classOgre_1_1Win32Window.html#ac9003bb550e61ce3040e87ae8ac961ec">getWindowHandle</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHWnd; }
<a name="l00065"></a><a class="code" href="classOgre_1_1Win32Window.html#ae7d19e6b7b2b570c8d6aabd686829617">00065</a>         HDC <a class="code" href="classOgre_1_1Win32Window.html#ae7d19e6b7b2b570c8d6aabd686829617">getHDC</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHDC; }
<a name="l00066"></a>00066         
<a name="l00067"></a>00067         <span class="comment">// Method for dealing with resize / move &amp; 3d library</span>
<a name="l00068"></a>00068         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowMovedOrResized(<span class="keywordtype">void</span>);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070         <span class="keywordtype">void</span> getCustomAttribute( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData );
<a name="l00071"></a>00071 
<a name="l00074"></a>00074         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setActive( <span class="keywordtype">bool</span> state );
<a name="l00075"></a>00075 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> adjustWindow(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> clientWidth, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> clientHeight, 
<a name="l00077"></a>00077             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* winWidth, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* winHeight);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keyword">protected</span>:
<a name="l00080"></a>00080         
<a name="l00082"></a>00082         <span class="keywordtype">void</span> updateWindowRect();
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1Win32Window.html#a7152359d1a55533ed0533fca8c833dec">00085</a>         DWORD <a class="code" href="classOgre_1_1Win32Window.html#a7152359d1a55533ed0533fca8c833dec" title="Return the target window style depending on the fullscreen parameter.">getWindowStyle</a>(<span class="keywordtype">bool</span> fullScreen)<span class="keyword"> const </span>{ <span class="keywordflow">if</span> (fullScreen) <span class="keywordflow">return</span> mFullscreenWinStyle; <span class="keywordflow">return</span> mWindowedWinStyle; }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     <span class="keyword">protected</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1Win32Window.html#ac9769188ae85b4123313d4ed763a19b6">00088</a>         <a class="code" href="classOgre_1_1Win32GLSupport.html">Win32GLSupport</a> &amp;<a class="code" href="classOgre_1_1Win32Window.html#ac9769188ae85b4123313d4ed763a19b6">mGLSupport</a>;
<a name="l00089"></a><a class="code" href="classOgre_1_1Win32Window.html#a9917bfd1ac9284fde3e5a6f8e4b33798">00089</a>         HWND    <a class="code" href="classOgre_1_1Win32Window.html#a9917bfd1ac9284fde3e5a6f8e4b33798">mHWnd</a>;                  <span class="comment">// Win32 Window handle</span>
<a name="l00090"></a><a class="code" href="classOgre_1_1Win32Window.html#a7945ae85ea25e5ada2738448d2654500">00090</a>         HDC     <a class="code" href="classOgre_1_1Win32Window.html#a7945ae85ea25e5ada2738448d2654500">mHDC</a>;
<a name="l00091"></a><a class="code" href="classOgre_1_1Win32Window.html#aed89543cc128d6f7ee9269e89f31cb72">00091</a>         HGLRC   <a class="code" href="classOgre_1_1Win32Window.html#aed89543cc128d6f7ee9269e89f31cb72">mGlrc</a>;
<a name="l00092"></a><a class="code" href="classOgre_1_1Win32Window.html#ad48a8790f0c1def9824ee750b0904306">00092</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#ad48a8790f0c1def9824ee750b0904306">mIsExternal</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1Win32Window.html#a8ecd2bf51cc3840fc9511a321efff30d">00093</a>         <span class="keywordtype">char</span>*   <a class="code" href="classOgre_1_1Win32Window.html#a8ecd2bf51cc3840fc9511a321efff30d">mDeviceName</a>;
<a name="l00094"></a><a class="code" href="classOgre_1_1Win32Window.html#a755b63c32e885d2163d145db1ab35bad">00094</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#a755b63c32e885d2163d145db1ab35bad">mIsExternalGLControl</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1Win32Window.html#a03bc7eeabfc6cb8312462285fd5b4b94">00095</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#a03bc7eeabfc6cb8312462285fd5b4b94">mIsExternalGLContext</a>;
<a name="l00096"></a><a class="code" href="classOgre_1_1Win32Window.html#aa32b8ddd15f71535a7ba8f4cc4f6ddcb">00096</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#aa32b8ddd15f71535a7ba8f4cc4f6ddcb">mSizing</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1Win32Window.html#a428e862dfa9a73211d50d03ab9eb2eb6">00097</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#a428e862dfa9a73211d50d03ab9eb2eb6">mClosed</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1Win32Window.html#ae9295ef45fcb766f71864211a54f6b6a">00098</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#ae9295ef45fcb766f71864211a54f6b6a">mHidden</a>;
<a name="l00099"></a><a class="code" href="classOgre_1_1Win32Window.html#a560e4d5a8aaf459237ad6b803c900018">00099</a>         <span class="keywordtype">bool</span>    <a class="code" href="classOgre_1_1Win32Window.html#a560e4d5a8aaf459237ad6b803c900018">mVSync</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1Win32Window.html#a49d842dd15d1731bfe474f0ebb6eef4e">00100</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Win32Window.html#a49d842dd15d1731bfe474f0ebb6eef4e">mVSyncInterval</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1Win32Window.html#a8b34ca1513a8ab826d1a9a3dd8922add">00101</a>         <span class="keywordtype">int</span>     <a class="code" href="classOgre_1_1Win32Window.html#a8b34ca1513a8ab826d1a9a3dd8922add">mDisplayFrequency</a>;      <span class="comment">// fullscreen only, to restore display</span>
<a name="l00102"></a><a class="code" href="classOgre_1_1Win32Window.html#aba30c8d137fb6409b6f1933a5693e2a6">00102</a>         <a class="code" href="classOgre_1_1Win32Context.html">Win32Context</a> *<a class="code" href="classOgre_1_1Win32Window.html#aba30c8d137fb6409b6f1933a5693e2a6">mContext</a>;
<a name="l00103"></a><a class="code" href="classOgre_1_1Win32Window.html#a59dd3567da9d268a222a71b714b6000d">00103</a>         DWORD   <a class="code" href="classOgre_1_1Win32Window.html#a59dd3567da9d268a222a71b714b6000d">mWindowedWinStyle</a>;      <span class="comment">// Windowed mode window style flags.</span>
<a name="l00104"></a><a class="code" href="classOgre_1_1Win32Window.html#a884836fb0e46fdbc3942eda93f915868">00104</a>         DWORD   <a class="code" href="classOgre_1_1Win32Window.html#a884836fb0e46fdbc3942eda93f915868">mFullscreenWinStyle</a>;    <span class="comment">// Fullscreen mode window style flags.</span>
<a name="l00105"></a>00105     };
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
